2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
22 prefix=$(git rev-parse --show-prefix) || exit 1
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
31 if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files)")
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
55 git ls-files -o $z $excl_opt -- "$@"
61 die "$(gettext "git stash clear with parameters is unimplemented")"
63 if current=$(git rev-parse --verify --quiet $ref_stash)
65 git update-ref -d $ref_stash $current
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
79 -u|--include-untracked)
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
91 git update-index -q --refresh
97 # state of the base commit
98 if b_commit=$(git rev-parse --verify HEAD)
100 head=$(git rev-list --oneline -n 1 HEAD --)
102 die "$(gettext "You do not have the initial commit yet")"
105 if branch=$(git symbolic-ref -q HEAD)
107 branch=${branch#refs/heads/}
111 msg=$(printf '%s: %s' "$branch" "$head")
114 i_tree=$(git write-tree) &&
115 i_commit=$(printf 'index on %s\n' "$msg" |
116 git commit-tree $i_tree -p $b_commit) ||
117 die "$(gettext "Cannot save the current index state")"
119 if test -n "$untracked"
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
124 untracked_files -z "$@" | (
125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
132 ) ) || die "$(gettext "Cannot save the untracked files")"
134 untracked_commit_option="-p $u_commit";
136 untracked_commit_option=
139 if test -z "$patch_mode"
142 # state of the working tree
144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
146 export GIT_INDEX_FILE &&
147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
152 die "$(gettext "Cannot save the current worktree state")"
156 rm -f "$TMP-index" &&
157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
161 git add--interactive --patch=stash -- "$@" &&
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
165 die "$(gettext "Cannot save the current worktree state")"
167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
168 test -s "$TMP-patch" ||
169 die "$(gettext "No changes selected")"
171 rm -f "$TMP-index" ||
172 die "$(gettext "Cannot remove temporary index (can't happen)")"
177 if test -z "$stash_msg"
179 stash_msg=$(printf 'WIP on %s' "$msg")
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
183 w_commit=$(printf '%s\n' "$stash_msg" |
184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
209 if test -z "$stash_msg"
211 stash_msg="Created via \"git stash store\"."
214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
216 test $ret != 0 && test -z "$quiet" &&
217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
243 -u|--include-untracked)
251 test -z ${1+x} && usage
263 eval_gettextln "error: unknown option for 'stash push': \$option"
273 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
275 if test -n "$patch_mode" && test -n "$untracked"
277 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
280 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
282 git update-index -q --refresh
285 say "$(gettext "No local changes to save")"
289 git reflog exists $ref_stash ||
290 clear_stash || die "$(gettext "Cannot initialize stash")"
292 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
293 store_stash -m "$stash_msg" -q $w_commit ||
294 die "$(gettext "Cannot save the current status")"
295 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
297 if test -z "$patch_mode"
299 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
300 if test -n "$untracked"
302 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
308 git ls-files -z --modified -- "$@" |
309 git checkout-index -z --force --stdin
310 git clean --force -q -d -- "$@"
315 if test "$keep_index" = "t" && test -n "$i_tree"
317 git read-tree --reset $i_tree
318 git ls-files -z --modified -- "$@" |
319 git checkout-index -z --force --stdin
322 git apply -R < "$TMP-patch" ||
323 die "$(gettext "Cannot remove worktree changes")"
325 if test "$keep_index" != "t"
342 # pass all options through to push_stash
343 push_options="$push_options $1"
354 if test -z "$stash_msg"
356 push_stash $push_options
358 push_stash $push_options -m "$stash_msg"
363 git rev-parse --verify --quiet $ref_stash >/dev/null
367 have_stash || return 0
368 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
372 ALLOW_UNKNOWN_FLAGS=t
373 assert_stash_like "$@"
377 if test "$(git config --bool stash.showStat || echo true)" = "true"
382 if test "$(git config --bool stash.showPatch || echo false)" = "true"
384 FLAGS=${FLAGS}${FLAGS:+ }-p
393 git diff ${FLAGS} $b_commit $w_commit
402 # Parses the remaining options looking for flags and
403 # at most one revision defaulting to ${ref_stash}@{0}
406 # Derives related tree and commit objects from the
407 # revision, if one is found.
409 # stash records the work tree, and is a merge between the
410 # base commit (first parent) and the index tree (second parent).
412 # REV is set to the symbolic version of the specified stash-like commit
413 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
414 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
415 # s is set to the SHA1 of the stash commit
416 # w_commit is set to the commit containing the working tree
417 # b_commit is set to the base commit
418 # i_commit is set to the commit containing the index tree
419 # u_commit is set to the commit containing the untracked files tree
420 # w_tree is set to the working tree
421 # b_tree is set to the base tree
422 # i_tree is set to the index tree
423 # u_tree is set to the untracked files tree
425 # GIT_QUIET is set to t if -q is specified
426 # INDEX_OPTION is set to --index if --index is specified.
427 # FLAGS is set to the remaining flags (if allowed)
430 # * too many revisions specified
431 # * no revision is specified and there is no stash stack
432 # * a revision is specified which cannot be resolve to a SHA1
433 # * a non-existent stash reference is specified
434 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
437 parse_flags_and_rev()
439 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
470 test "$ALLOW_UNKNOWN_FLAGS" = t ||
471 die "$(eval_gettext "unknown option: \$opt")"
472 FLAGS="${FLAGS}${FLAGS:+ }$opt"
475 REV="${REV}${REV:+ }'$opt'"
484 have_stash || die "$(gettext "No stash entries found.")"
485 set -- ${ref_stash}@{0}
491 die "$(eval_gettext "Too many revisions specified: \$REV")"
500 set -- "${ref_stash}@{$1}"
504 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
506 die "$(eval_gettext "\$reference is not a valid reference")"
509 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
510 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
518 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
521 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
522 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
527 parse_flags_and_rev "$@"
528 test -n "$IS_STASH_LIKE"
531 assert_stash_like() {
532 is_stash_like "$@" || {
534 die "$(eval_gettext "'\$args' is not a stash-like commit")"
539 is_stash_like "$@" && test -n "$IS_STASH_REF"
543 is_stash_ref "$@" || {
545 die "$(eval_gettext "'\$args' is not a stash reference")"
551 assert_stash_like "$@"
553 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
555 # current index state
556 c_tree=$(git write-tree) ||
557 die "$(gettext "Cannot apply a stash in the middle of a merge")"
559 unstashed_index_tree=
560 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
561 test "$c_tree" != "$i_tree"
563 git diff-tree --binary $s^2^..$s^2 | git apply --cached
565 die "$(gettext "Conflicts in index. Try without --index.")"
566 unstashed_index_tree=$(git write-tree) ||
567 die "$(gettext "Could not save index tree")"
573 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
574 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
576 die "$(gettext "Could not restore untracked files from stash entry")"
580 GITHEAD_$w_tree='Stashed changes' &&
581 GITHEAD_$c_tree='Updated upstream' &&
582 GITHEAD_$b_tree='Version stash was based on' &&
583 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
586 if test -n "$GIT_QUIET"
588 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
590 if git merge-recursive $b_tree -- $c_tree $w_tree
593 if test -n "$unstashed_index_tree"
595 git read-tree "$unstashed_index_tree"
598 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
599 git read-tree --reset $c_tree &&
600 git update-index --add --stdin <"$a" ||
601 die "$(gettext "Cannot unstage modified files")"
605 if test -n "$GIT_QUIET"
607 squelch='>/dev/null 2>&1'
609 (cd "$START_DIR" && eval "git status $squelch") || :
611 # Merge conflict; keep the exit status from merge-recursive
614 if test -n "$INDEX_OPTION"
616 gettextln "Index was not unstashed." >&2
623 assert_stash_ref "$@"
630 say "$(gettext "The stash entry is kept in case you need it again.")"
636 assert_stash_ref "$@"
638 git reflog delete --updateref --rewrite "${REV}" &&
639 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
640 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
642 # clear_stash if we just dropped the last stash entry
643 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
648 test -n "$1" || die "$(gettext "No branch name specified")"
653 assert_stash_like "$@"
655 git checkout -b $branch $REV^ &&
656 apply_stash "$@" && {
657 test -z "$IS_STASH_REF" || drop_stash "$@"
661 test "$1" = "-p" && set "push" "$@"
663 PARSE_CACHE='--not-parsed'
664 # The default command is "push" if nothing but options are given
671 *) seen_non_option=t; break ;;
675 test -n "$seen_non_option" || set "push" "$@"
705 create_stash -m "$*" && echo "$w_commit"
727 say "$(gettext "(To restore them type \"git stash apply\")")"